; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
; 

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629
    
    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16
            
      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

; 

    abs0 MACRO
        push eax
        and eax, 80000000h
        cmp eax, 80000000h
        pop eax
        jnz @f
        neg eax
      @@:
    ENDM

    abs1 MACRO
        test eax, 80000000h
        jz @F
        neg eax
      @@:
    ENDM

    abs2 MACRO
        test eax, 80000000h
        jns @F
        neg eax
      @@:
    ENDM

    abs3 MACRO
      mov ebx, eax
      sar eax, 31
      add ebx, eax
      xor ebx, eax
    ENDM

    abs4 MACRO
      cdq
      xor eax,edx
      sub eax,edx
    ENDM

; 
    .data
    .code
; 
start:
; 

    ; ---------------
    ; Test generator.
    ; ---------------
    REPEAT 100
      print str$(@rnd(0ffffffffh)),13,10
    ENDM
    print chr$(13,10,13,10)

    FOR arg,<0,1,2147483647,-1,-2147483647,-2147483648>

      mov eax, arg
      abs0
      print ustr$(eax),"  "

      mov eax, arg
      abs1
      print ustr$(eax),"  "

      mov eax, arg
      abs2
      print ustr$(eax),"  "

      mov eax, arg
      abs3
      print ustr$(ebx),"  "

      mov eax, arg
      abs4
      print ustr$(eax),"  "

      mov eax, arg
      invoke crt_abs, eax
      print ustr$(eax),13,10,13,10

    ENDM

    invoke Sleep, 4000

    ; -------------------------------
    ; Restart sequence for each test.
    ; -------------------------------

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        abs0
      ENDM
    counter_end
    print ustr$(eax), " cycles, abs0",13,10

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629   

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        abs1
      ENDM
    counter_end
    print ustr$(eax), " cycles, abs1",13,10

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        abs2
      ENDM
    counter_end
    print ustr$(eax), " cycles, abs2",13,10

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        abs3
      ENDM
    counter_end
    print ustr$(eax), " cycles, abs3",13,10

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        abs4
      ENDM
    counter_end
    print ustr$(eax), " cycles, abs4",13,10

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    counter_begin 1000, HIGH_PRIORITY_CLASS
      REPEAT 200
        mov eax, @rnd(0ffffffffh)
        invoke crt_abs, eax
      ENDM
    counter_end
    print ustr$(eax), " cycles, crt_abs",13,10,13,10

    inkey "Press any key to exit..."
    exit
; 
end start
